pragma Ada_95;
pragma Source_File_Name (zlib_adamain, Spec_File_Name => "b~zlib_ada.ads");
pragma Source_File_Name (zlib_adamain, Body_File_Name => "b~zlib_ada.adb");

with System.Restrictions;

package body zlib_adamain is
   pragma Warnings (Off);

   procedure Do_Finalize;
   pragma Import (C, Do_Finalize, "system__standard_library__adafinal");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   procedure zlib_adainit is
      E16 : Boolean; pragma Import (Ada, E16, "system__soft_links_E");
      E26 : Boolean; pragma Import (Ada, E26, "system__exception_table_E");
      E80 : Boolean; pragma Import (Ada, E80, "ada__io_exceptions_E");
      E50 : Boolean; pragma Import (Ada, E50, "ada__tags_E");
      E73 : Boolean; pragma Import (Ada, E73, "ada__streams_E");
      E58 : Boolean; pragma Import (Ada, E58, "interfaces__c_E");
      E60 : Boolean; pragma Import (Ada, E60, "interfaces__c__strings_E");
      E20 : Boolean; pragma Import (Ada, E20, "system__secondary_stack_E");
      E72 : Boolean; pragma Import (Ada, E72, "system__finalization_root_E");
      E75 : Boolean; pragma Import (Ada, E75, "system__finalization_implementation_E");
      E70 : Boolean; pragma Import (Ada, E70, "ada__finalization_E");
      E68 : Boolean; pragma Import (Ada, E68, "ada__finalization__list_controller_E");
      E02 : Boolean; pragma Import (Ada, E02, "zlib_E");
      E04 : Boolean; pragma Import (Ada, E04, "zlib__streams_E");
      E06 : Boolean; pragma Import (Ada, E06, "zlib__thin_E");

      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Zero_Cost_Exceptions : Integer;
      pragma Import (C, Zero_Cost_Exceptions, "__gl_zero_cost_exceptions");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");

      procedure Install_Handler;
      pragma Import (C, Install_Handler, "__gnat_install_handler");

      Handler_Installed : Integer;
      pragma Import (C, Handler_Installed, "__gnat_handler_installed");
   begin
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      System.Restrictions.Run_Time_Restrictions :=
        (Set =>
          (False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False),
         Value => (0, 0, 0, 0, 0, 0, 0),
         Violated =>
          (False, False, True, True, False, False, False, False, 
           True, False, True, True, True, False, False, True, 
           False, False, True, True, False, True, False, True, 
           True, False, True, False, False, True, False, True, 
           False, False, False, False, False, True, False, False, 
           False, True, False, False, True, False, False, False, 
           False, False, False, False, False, True, True, True, 
           False, False, True, False, True, True, False, True, 
           True, False, False, False, False, False, False, False, 
           False),
         Count => (0, 0, 0, 0, 0, 0, 0),
         Unknown => (False, False, False, False, False, False, False));
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Zero_Cost_Exceptions := 1;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      if Handler_Installed = 0 then
         Install_Handler;
      end if;

      if not E26 then
         System.Exception_Table'Elab_Body;
         E26 := True;
      end if;
      if not E80 then
         Ada.Io_Exceptions'Elab_Spec;
         E80 := True;
      end if;
      if not E50 then
         Ada.Tags'Elab_Spec;
      end if;
      if not E73 then
         Ada.Streams'Elab_Spec;
         E73 := True;
      end if;
      if not E58 then
         Interfaces.C'Elab_Spec;
      end if;
      if not E60 then
         Interfaces.C.Strings'Elab_Spec;
      end if;
      E60 := True;
      E58 := True;
      if not E50 then
         Ada.Tags'Elab_Body;
         E50 := True;
      end if;
      if not E16 then
         System.Soft_Links'Elab_Body;
         E16 := True;
      end if;
      if not E20 then
         System.Secondary_Stack'Elab_Body;
         E20 := True;
      end if;
      if not E72 then
         System.Finalization_Root'Elab_Spec;
      end if;
      E72 := True;
      if not E75 then
         System.Finalization_Implementation'Elab_Spec;
      end if;
      if not E75 then
         System.Finalization_Implementation'Elab_Body;
         E75 := True;
      end if;
      if not E70 then
         Ada.Finalization'Elab_Spec;
      end if;
      E70 := True;
      if not E68 then
         Ada.Finalization.List_Controller'Elab_Spec;
      end if;
      E68 := True;
      if not E02 then
         Zlib'Elab_Spec;
      end if;
      if not E04 then
         Zlib.Streams'Elab_Spec;
      end if;
      E04 := True;
      if not E06 then
         Zlib.Thin'Elab_Body;
         E06 := True;
      end if;
      E02 := True;
   end zlib_adainit;

   procedure zlib_adafinal is
   begin
      Do_Finalize;
   end zlib_adafinal;

--  BEGIN Object file/option list
   --   ./zlib-streams.o
   --   ./zlib-thin.o
   --   ./zlib.o
   --   -L./
   --   -L/builddir/build/BUILD/zlib-ada/x86_64/
   --   -L/usr/lib/gcc/x86_64-redhat-linux/4.6.3/adalib/
   --   -static
   --   -lgnat
--  END Object file/option list   

end zlib_adamain;
